{$mode objfpc}{$assertions on}{$r+}
uses
  Math;
var
  t, l, r: array of Integer;
  W, H, N: Integer;

  function Solve: Integer;
  var
    i, j, x1, x2: Integer;
  begin
    for i := 1 to N do begin
      Read(x1, x2);
      Assert(InRange(x1, 1, W) and InRange(x2, 1, W));
      if t[x1] = H then Exit(i);
      if (x2 > x1) and (r[x1] <= x2) then Exit(i);
      if (x2 < x1) and (l[x1] >= x2) then Exit(i);
      t[x2] += 1;
      j := Max(x2 - H + t[x2], 0);
      r[j] := Min(r[j], x2);
      j := Min(x2 + H - t[x2], W + 1);
      l[j] := Max(l[j], x2);
    end;
    Result := 0;
  end;

var
  x, y: Integer;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Read(W, H, N);
  Assert(InRange(W, 1, 10000) and InRange(H, 1, 10000) and InRange(N, 1, 1000000));
  SetLength(t, W + 1);
  SetLength(l, W + 2);
  SetLength(r, W + 2);
  for x := 0 to High(t) do t[x] := 0;
  for x := 0 to High(l) do l[x] := x - H;
  for x := 0 to High(r) do r[x] := x + H;
  Writeln(Solve);
  {for x := 1 to W do Write(Min(r[x], 9));
  Writeln;
  for x := 1 to W do Write(Max(l[x], 0));
  Writeln;
  for y := 1 to H do begin
    for x := 1 to W do
      if t[x] > H - y then Write('#') else Write('.');
    Writeln;
  end;}
end.
