{$mode objfpc}{$assertions on}
uses
  Math;
var
  a: array of array of Char;
  i, x1, x2, y, W, H, N: Integer;

  function Solve: Integer;
  begin
    for i := 1 to N do begin
      Read(x1, x2);
      Assert(InRange(x1, 1, W) and InRange(x2, 1, W));
      if a[1, x1] <> '.' then Exit(i);
      y := 1;
      while (y < H) and (a[y + 1, x1 + Sign(x2 - x1)] = '.') do begin
        x1 += Sign(x2 - x1);
        y += 1;
      end;
      if x1 <> x2 then Exit(i);
      a[y, x1] := '#';
    end;
    Result := 0;
  end;

begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Read(W, H, N);
  SetLength(a, H + 1, W + 1);
  for y := 1 to H do
    for x1 := 1 to W do
      a[y, x1] := '.';
  Writeln(Solve);
  {for y := 1 to H do begin
    for x1 := 1 to W do
      Write(a[y, x1]);
    Writeln;
  end;}
end.
